/*-------------------------------------------*\
 |  EJEMPLO 2.15                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Generacin de ondas cuadradas de direntes frecuencias variando el valor del TMR0

// La lnea de salida RB0 cambiar de estado a una frecuencia determinda por el valor
// introducido mediante los 3 interruptores RA0-RA2:

/*
	RA2 RA1 RA0 Frecuencia Periodo Semiperiodo
	--- --- --- ---------- ------- -----------
	 0   0   0     0 KHz     ---       ---
         0   0   1     1 KHz    1000us    500us
         0   1   0     2 KHz     500us    250us
         0   1   1     3 KHz     333us    166us
         1   0   0     4 KHz     250us    125us
         1   0   1     5 KHz     200us    100us
         1   1   0     6 KHz     166us     83us
         1   1   1     7 KHz     143us     71us
*/

#include <16f84.h>

#use delay(clock=4000000)

#use fast_io(A)
#use fast_io(B)

#byte port_a = 5
#byte port_b = 6

int tabla[8]={0x00, 0x86, 0xC5, 0xDA, 0xE4, 0xEA, 0xEE, 0xf1};
int valor=1;

#INT_RTCC
timer_handler()
{
  set_rtcc(valor);
  port_b ^= 0x01;
}


main()
{
  int a;

  setup_counters(RTCC_INTERNAL,RTCC_DIV_4);

  enable_interrupts(RTCC_ZERO);
  enable_interrupts(GLOBAL);

  while(1)
  {
    a = port_a & 0x07;
    if(a==0)
      disable_interrupts(GLOBAL);
    else
    {
      valor = tabla[a];
      enable_interrupts(GLOBAL);
    }
  }
}
