/*-------------------------------------------*\
 |  EJEMPLO 3.5                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Wake-up (despertar) del modo SLEEP mediante interrupcin RB0.

// La interrupcin se produce con el flanco descendente de RB0. RB0 est conectada,
// mediante la tecla 1, con RB4. A RB4 se le configura como salida a nivel "0". RB0
// se configura como entrada con carga Pull_Up. Si la tecla est sin pulsar (abierta),
// RB0 permanecer a "1". Cuando se pulsa la tecla RB0 pasar a "0" provocndose la
// interrupcin que finalizar el modo SLEEP de bajo consumo.

// El programa de tratamiento de la interrupcin provoca el encendido del led
// conectado a RB7 durante 1 segundo para luego desconectarlo y volver al modo SLEEP.

// Se recomienda poner el WDT en OFF para que no sea l quien provoque el Wake-UP y
// desconectar el LCD mediante el jumper J6 para que no interfiera con la lnea RB0.

#include <16f84.h>

#use delay(clock=4000000)
#use fast_io(B)

#byte port_b = 6

#INT_EXT
Ext_Int_Handler()
{
  output_bit(PIN_B7,1);
  delay_ms(1000);
  output_Bit(PIN_B7,0);
  while(!input(PIN_B0));
}

main()
{
  port_b = 0;
  set_tris_b(0x0F);	// RB0-RB3 entradas, RB4-RB7 salidas.
  port_b_pullups(TRUE); // Cargas Pull-Ups activadas.

  enable_interrupts(INT_EXT);
  enable_interrupts(GLOBAL);

  while(1)
    sleep();
}
