/*-------------------------------------------*\
 |  EJEMPLO 3.6                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Comunicacin serie gestionada por software.

// Haciendo uso de las rutinas incluidas las libreras del compilador C, se trata
// de utilizar el canal RS232 de la Trainer PLUS para comunicar va serie con 
// diferentes perifricos. En los ejemplos aqu propuestos se utilizar un PC para
// que, con el software TERMINAL.EXE, actue como un simple terminal de comunicaciones.
// El usuario deber preparar los cables de comunicacin entre la Trainer PLUS y el
// PC, teniendo en cuenta de cruzar la seal de transmisin (TxD) con la de
// recepcin (RxD) y viceversa.

// Este ejemplo propone esperar a recibir un carcter desde el terminal para,
// inmediatamente retransmitirlo a modo de ECO.

#include <16f84.h>

#use delay(clock=4000000)
#use RS232(BAUD=9600, BITS=8, PARITY=N, XMIT=PIN_B4, RCV=PIN_B5, RESTART_WDT)
//
// 9600 baudios, 8 bits de datos, sin paridad.
// RESTART_WDT: La funcin "getc()" mientras se encuentra esperando la llegada
//              de caracteres se encarga de ir refrescando el WDT.
//
//   ------------*                  *--------
//               |                  |
//   P   RB4(TxD)|----------------->|(RxD)
//   I           |                  |       PC
//   C   RB5(RxD)|<-----------------|(TxD)
//               |                  |
//   ------------*                  *--------

main()
{
  char c;

  while(1)
  {
    c = getc();		// Espera hasta que llegue un caracter via serie.
    putc(c);		// Transmite via serie el caracter que acaba de llegar.
  }
}
