/*-------------------------------------------*\
 |  EJEMPLO 3.7                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Comunicacin serie gestionada por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de utilizar el canal RS232 de la Trainer PLUS para comunicar va serie con 
// diferentes perifricos. En los ejemplos aqu propuestos se utilizar un PC para
// que, con el software TERMINAL.EXE, actue como un simple terminal de comunicaciones.
// El usuario deber preparar los cables de comunicacin entre la Trainer PLUS y el
// PC, teniendo en cuenta de cruzar la seal de transmisin (TxD) con la de
// recepcin (RxD) y viceversa.

// Este ejemplo es similar al anterior. Propone esperar a recibir un caracter desde
// el terminal para, inmediatamente, retransmitirlo al mismo a modo de ECO y
// visualizarlo sobre la pantalla LCD del MicroPIC Trainer.

#include <16f84.h>

#use delay(clock=4000000)
#use RS232(BAUD=9600, BITS=8, PARITY=N, XMIT=PIN_B4, RCV=PIN_B5, RESTART_WDT)

#use fast_io(A)
#use fast_io(B)
#include <lcd2.c>

#byte port_a=5
#byte port_b=6

main()
{
  int x=1, y=1;
  char c;

  lcd_init();
  lcd_enviar(LCD_COMANDO,LCD_CURSOR_BLINK);

  while(1)
  {
    // ATENCION:	Las funciones de gestin del LCD, reprograman
    // ---------	las puertas A y B segn sea necesario, por lo
    //			antes de utilizar las funciones serie RS232 es
    //			necesario reprogramar las lines TxD y RxD.

    port_b =   0b00010000;   // TxD a "1". Inactiva.
    set_tris_b(0b00100000);  // PIN_B4 = Salida(TxD), PIN_B5 = Entrada(RxD)
    c = getc();	
    putc(c);

    lcd_gotoxy(x,y);
    lcd_putc(c);
    x++;
    if(x>16)
    {
      x=1; y++;
      if(y>2)
        y=1;
    }
  }
}
