/*-------------------------------------------*\
 |  EJEMPLO 3.8                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Comunicacin serie gestionada por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de utilizar el canal RS232 de la Trainer PLUS para comunicar va serie con 
// diferentes perifricos. En los ejemplos aqu propuestos se utilizar un PC para
// que, con el software TERMINAL.EXE, actue como un simple terminal de comunicaciones.
// El usuario deber preparar los cables de comunicacin entre la Trainer PLUS y el
// PC, teniendo en cuenta de cruzar la seal de transmisin (TxD) con la de
// recepcin (RxD) y viceversa.

// Este programa pretende mostrar en envo de mensajes desde el PIC de la MicroPIC
// Trainer, a travs del canal serie de la Trainer PLUS, hacia el terminal. Cada vez
// que se pulse RETURN, se repite el envo de los mismos mensajes. Se emplea una rutina
// de salida de mensajes similar a al empleada en los ejemplos del LCD.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use RS232(BAUD=9600, BITS=8, PARITY=N, XMIT=PIN_B4, RCV=PIN_B5, RESTART_WDT)
#use fast_io(B)

main()
{
  char const mens1[28]="Microsystems Engineering";
  char const mens2[31]="Gral. Concha 39 48012 Bilbao";
  char const mens3[23]="Tfno./Fax 94 4223263";
  int n=0;
  char c;

  set_tris_b(0x20);

  while(1)
  {
    restart_wdt();
    do
    {
      c = getc();		// Espera hasta que llegue un caracter via serie.
    } while(c != '\r');
 
    switch(n)
    {
      case 0: puts(mens1); break;
      case 1: puts(mens2); break;
      case 2: puts(mens3); break;
    }
    n++;
    if(n==3)
      n=0;
  }
}
