/*-------------------------------------------*\
 |  EJEMPLO 3.9                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Comunicacin serie gestionada por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de utilizar el canal RS232 de la Trainer PLUS para comunicar va serie con 
// diferentes perifricos. En los ejemplos aqu propuestos se utilizar un PC para
// que, con el software TERMINAL.EXE, actue como un simple terminal de comunicaciones.
// El usuario deber preparar los cables de comunicacin entre la Trainer PLUS y el
// PC, teniendo en cuenta de cruzar la seal de transmisin (TxD) con la de
// recepcin (RxD) y viceversa.

// Este programa pretende ser un simple programa de monitorizacin. Se lee el estado
// de los interruptores RA0-RA4 de la MicroPIC Trainer y se enva, va serie a un
// terminal para monitorizar el estado de los mismos.

#include <16f84.h>

#use delay(clock=4000000)
#use RS232(BAUD=9600, BITS=8, PARITY=N, XMIT=PIN_B4, RCV=PIN_B5, RESTART_WDT)
#use fast_io(B)

#byte port_a = 5

main()
{
  signed int i;		// Variable con signo, ya que lleger a valer <0

  set_tris_a(0x1F);
  set_tris_b(0x20);

  while(1)
  {
    restart_wdt();
    printf("Puerta A:");
    for(i=4; i>=0; i--)
      printf("  RA%1u=%c",i,bit_test(port_a,i)+'0');
    putc('\n');
    putc('\r');
  }
}
