/*-------------------------------------------*\
 |  EJEMPLO 2.13                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Contador UP/DOWN binario

// Sobre los 8 leds de salida conectados a la puerta B se visualizar, en binario,
// el nmero de pulsos aplicados por la entrada RA0. RA1 determina si la cuenta es
// ascendente (a "1") o descendente.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#byte port_a = 5
#byte port_b = 6

main()
{
  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  while(1)
  {
    do {
      restart_wdt();
    } while(input(PIN_A0));	// Esperar flanco ascendente
    delay_ms(20);

    do {
      restart_wdt();
    } while(!input(PIN_A0));	// Esperar flanco descendente
    delay_ms(20);

    if(input(PIN_A1))
      port_b++;
    else
      port_b--;
  }
}
