/*-------------------------------------------*\
 |  EJEMPLO 2.14                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Contador UP/DOWN decimal de un dgito.

// Sobre el display de 7 segmentos conectado a la puerta B se visualizar el
// nmero de pulsos aplicados por la entrada RA0. RA1 determinar si la cuenta
// es ascendente (a "1") o descendente (a "0").

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#byte port_a = 5
#byte port_b = 6

main()
{
  unsigned int const disp[10]={0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x27,0x7F,0x6F};
  signed int conta=0;	//Variable con signo, ya que se preguntar si es (conta < 0).

  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  while(1)
  {
    do {
      restart_wdt();
    } while(input(PIN_A0));	// Esperar flanco ascendente
    delay_ms(20);

    do {
      restart_wdt();
    } while(!input(PIN_A0));	// Esperar flanco descendente
    delay_ms(20);

    if(input(PIN_A1))
    {
      conta++;
      if(conta>9)
        conta=0;
    }
    else
    {
      conta--;
      if(conta<0)
        conta=9;
    }

    port_b = disp[conta];
  }
}
