/*-------------------------------------------*\
 |  EJEMPLO 2.16                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Generacin de nmeros aleatorios.

// Cada vez que se aplique in pulso por RA0, se genera un nmero binario de 8
// bits aleatorio que ser visualizado sobre los 8 leds conectados en la puerta B,
// durante 3 segundos.

// Entre las diferentes tcnicas, la empleada para obtener el nmero, consiste
// en capturar el valor del MTR0 en un momento dado.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#byte port_b = 6

main()
{
  int numero;

  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  setup_counters(RTCC_INTERNAL,RTCC_DIV_256);

  while(1)
  {
    do {
      restart_wdt();
    } while(!input(PIN_A0));
    delay_ms(20);

    numero = get_rtcc();

    do {
      restart_wdt();
    } while(input(PIN_A0));
    delay_ms(20);

    port_b = Numero;
    delay_ms(3000);
    port_b = 0;
  }
}
