/*-------------------------------------------*\
 |  EJEMPLO 2.17                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Generacin de nmeros aleatorios. El dado electrnico.

// Se trata de generar un nmero aleatorio entre 1 y 6. Cuando RA0 esta a "1",
// sobre el display 7 segmentos conectado a la puerta B, se van visualizando de
// forma secuencial los nmeros del 1 al 6, con intervalos de 0.05s. Al pasar
// RA0 a nivel "0", se visualiza el nmero aleatorio obtenido durante un tiempo
// de 3s. Luego el display se apaga y la secuencia se repite.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#byte port_a = 5
#byte port_b = 6

main()
{
  unsigned int const disp[6]={0x06,0x5B,0x4F,0x66,0x6D,0x7D};
  int numero;

  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  setup_counters(RTCC_INTERNAL,RTCC_DIV_256);

  while(1)
  {
    do {
      restart_wdt();
    } while(!input(PIN_A0));
    delay_ms(20);		// Esperar nivel "1" en RA0

    numero = 0;
    do {
      restart_wdt();
      port_b = disp[numero];
      numero++;
      if(numero>5)
        numero = 0;
      delay_ms(50);
    } while(input(PIN_A0));	// Esperar nivel "0" en RA0
    delay_ms(20);

    numero = get_rtcc() % 6;

    port_b = disp[numero];
    delay_ms(3000);
    port_b = 0;
  }
}
