/*-------------------------------------------*\
 |  EJEMPLO 2.19                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// La memoria EEPROM de datos. La mquina "SU TURNO"

// Se trata de emular el funcionamiento de las mquinas tipo "SU TURNO" habituales
// en mltiples comercios. Sobre el display se visualizar el nmero del turno
// actual. Este se incrementar a cada pulso aplicado por RA0. En la memoria EEPROM
// del PIC16F84 se almacena el ltimo nmero visualizado, de forma que, ante un fallo
// de alimentacin (p.e.), se reanude la cuenta en el ltimo nmero.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#byte port_a = 5
#byte port_b = 6

main()
{
  unsigned int const disp[10]={0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x27,0x7F,0x6F};
  int conta;
  
  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  conta = read_eeprom(0);
  if(conta>9)
    conta=0;

  while(1)
  {
    port_b = disp[conta];

    do {
      restart_wdt();
    } while(!input(PIN_A0));	// Esperar flanco ascendente
    delay_ms(20);

    do {
      restart_wdt();
    } while(input(PIN_A0));	// Esperar flanco descendente
    delay_ms(20);

    conta++;
    if(conta>9)
      conta=0;
    write_eeprom(0,conta);
  }
}
