/*-------------------------------------------*\
 |  EJEMPLO 2.2                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Control de los leds RB0 y RB1 desde el interruptor RA0. RB0 refleja el 
// estado de RA0, RB1 el complemento de RA0.

#include <16f84.h>

#use fast_io(A)
#use fast_io(B)
// Con estas directivas las funciones "input" y "output_bit" no reprograman
// el pin de la puerta cada vez que son utilizadas. Si no se indica el
// modo fast_io se asume por defecto standard_io el cual reprograma el pin
// siempre antes de ser utilizadas estas funciones.


main()
{
  set_tris_a(0x1F);
  set_tris_b(0x00);

  while(1)
    if(input(PIN_A0))         // Leer RA0 y preguntar por su valor
    {                            // RA0 es 1
      output_bit(PIN_B0,1);         // Poner RB0 a 1
      output_bit(PIN_B1,0);         // Poner RB1 a 0
    }
    else
    {                            // RA0 es 0
      output_bit(PIN_B0,0);         // Poner RB0 a 0
      output_bit(PIN_B1,1);         // Poner RB1 a 1
    }
}
