/*-------------------------------------------*\
 |  EJEMPLO 2.22                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// El manejo de la pantalla LCD.

// Este ejemplo pretende introducirnos en el manejo de la pantalla LCD, para la
// visualizacin de diferentes mensajes.

// Debe recordarse que las lneas RA0-RA2 actan ahora como salida de seales de
// control hacia el LCD. Al estar conectadas con sendos interruptores en la MicroPIC
// Trainer, estos deben estar a nivel lgico "1" permanentemente.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#include <lcd2.c>

#use fast_io(A)
#use fast_io(B)

main() {

  lcd_init();	// Comandos de inicializacin del LCD.
  while(1)
  {
    restart_wdt();
    lcd_enviar(LCD_COMANDO, LCD_CLEAR);
    lcd_enviar(LCD_COMANDO, LCD_HOME);
    lcd_putc("Microsystems\n");		// El caracter \n salta a la segunda lnea
    lcd_putc("Engineering");
    delay_ms(4000);

    restart_wdt();
    lcd_enviar(LCD_COMANDO, LCD_CLEAR);
    lcd_enviar(LCD_COMANDO, LCD_HOME);
    lcd_putc("Gral. Concha 39");
    lcd_gotoxy(1,2);			// Otra forma de saltar a la segunda lnea
    lcd_putc("48012 Bilbao");
    delay_ms(4000);
  }
}
