/*-------------------------------------------*\
 |  EJEMPLO 2.3                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Programa combinacional. Segn el estado de los interruptores RA0 y RA1, activar
// los leds RB0-RB7 conectados a la puerta B, conforme a la siguiente tabla de
// la verdad:
//
// RA1 RA0  RB7 RB6 RB5 RB4 RB3 RB2 RB1 RB0
// --- ---  --- --- --- --- --- --- --- ---
//  0   0    1   0   1   0   1   0   1   0
//  0   1    0   1   0   1   0   1   0   1
//  1   0    0   0   0   0   1   1   1   1
//  1   1    1   1   1   1   0   0   0   0

#include <16f84.h>

#byte port_a = 5	// Identificador asociado al registro de direccin 5
#byte port_b = 6	// Identificador asociado al registro de direccin 6


main()
{
  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  while(1)
    switch(port_a)
    {
      case 0: port_b = 0b10101010; break;
      case 1: port_b = 0b01010101; break;
      case 2: port_b = 0b00001111; break;
      case 3: port_b = 0b11110000; break;
    }
}
