/*-------------------------------------------*\
 |  EJEMPLO 2.5                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Programa combinacional. Simulacin del control de una mquina de torneado.

// La secuencia se inicia al pulsar "I" (RA0) que activa el cilindro "V" (RB0).
// Este en su avance empuja la pieza a tornear y acciona el sensor "b" (RA2)
// activando el rel del motor "M" (RB1). Comienza el torneado. Durante el avance
// se alcanza el sensor "c" (RA3) que desactiva el cilindro "V" (RB0) inicindose
// el retroceso del mismo. Al volver a pasar por "b" (RA2), se desconecta "M" (RB1).
// Cuando se alcanza el final de carrera "a" (RA1) se activa una seal acstica "A"
// (RB2) para que el operario retire la pieza, coloque otra nueva y, se inicie un
// nuevo ciclo, al pulsar "I" (RA0).

#include <16f84.h>

#use delay(clock=4000000)

#use fast_io(A)
#use fast_io(B)

#byte port_b = 6

main()
{
  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);
  
  while(1)
  {
    do {
      restart_wdt();
    } while(!input(PIN_A0));     // Esperar que se pulse "I"
      
      
    output_bit(PIN_B2,0);        // Desactivar seal acustica
    output_bit(PIN_B0,1);        // Activar cilindro "V"
    
    do {
      restart_wdt();
    } while(!input(PIN_A2));     // Esperar sensor "b"
      
    output_bit(PIN_B1,1);        // Activar "M"
    
    do {
      restart_wdt();
    } while(!input(PIN_A3));	// Esperar sensor "c"

    output_bit(PIN_B0,0);	// Desactivar cilindro "V"

    do {
      restart_wdt();
    } while(!input(PIN_A2));     // Esperar otra vez sensor "b"
      
    output_bit(PIN_B1,0);        // Desconectar "M"
    
    do {
      restart_wdt();
    } while(!input(PIN_A1));     // Esperar sensor "a"
      
    output_bit(PIN_B2,1);        // Activar seal acstica
  }
}
