/*-------------------------------------------*\
 |  EJEMPLO 2.6                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Mquina de taladrado

// Al accionar el pulsador "I" (RA0) el cabezal realiza un descenso rpido de
// aproximacin, activando el motor de bajada rpida "BR" (RB3). Al llegar al
// sensor "b" (RA2), se activa el rel "M" (RB1) que hace girar el motor de la
// broca y se realiza un descenso lento para el taladrado de la pieza "BL" (RB4).
// Cuando se activa el sensor "c" (RA3) se considera que la pieza est taladrada.
// Se inicia una subida rpida del cabezal "SR" (RB0) al tiempo que el rel "M"
// (RB1) de giro sigue activado. Cuando se alcanza el final de carrera "a" (RA1),
// se detiene la subida rpida "SR" (RB0), el rel de giro "M" (RB1) y se activa
// una seal acustica "A" (RB2) de aviso. El ciclo comienza con una nueva pulsacin
// de "I" (RA0)

#include <16f84.h>

#use delay(clock=4000000)

#use fast_io(A)
#use fast_io(B)

#byte port_b = 6

main()
{
  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  while(1)
  {
    do {
      restart_wdt();
    } while(!input(PIN_A0));	// Esperar que se pulse "I"

    output_bit(PIN_B2,0);	// Desactivar seal acstica
    output_bit(PIN_B3,1);	// Activar "BR"

    do {
      restart_wdt();
    } while(!input(PIN_A2));	// Esperar sensor "b"

    output_bit(PIN_B3,0);	// Desactivar "BR"
    output_bit(PIN_B4,1);	// Activar "BL"
    output_bit(PIN_B1,1);	// Activar "M"

    do {
      restart_wdt();
    } while(!input(PIN_A3));	// Esperar sensor "c"

    output_bit(PIN_B4,0);	// Desactivar "BL"
    output_bit(PIN_B0,1);	// Activar "SR"

    do {
      restart_wdt();
    } while(!input(PIN_A1));	// Esperar sensor "a"

    output_bit(PIN_B2,1);	// Activar seal acstica
    output_bit(PIN_B0,0);	// Desactivar "SR"
    output_bit(PIN_B1,0);	// Parar "M"
  }
}
