/*-------------------------------------------*\
 |  EJEMPLO 2.7                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Mquina de embasado

// Dos rels "M1" (RB0) y "M2" (RB1) gobiernan dos motores que arrastran dos
// cintas transportadoras. "M1" (RB0) transporta piezas y "M2" (RB1) embalajes.
// Un sensor "DP" (RA1) detecta el paso de piezas y, otro "DE" (RA2), dectecta
// el correcto posicionamiento de un embase. Al detectarse el paso de 10 piezas,
// el embase se considera lleno, se activa una seal acstica "A" (RB2) y, la
// cinta que transportaba embalajes, se desplaza hasta situar un nuevo embase
// vaco. En este momento se desactiva la seal acstica "A" (RB2) y nuevamente
// avanza la cinta de piezas repitindose as el ciclo. Un interruptor "I" (RA0)
// activa o no todo el sistema.

#include <16f84.h>

#use delay(clock=4000000)

#use fast_io(A)
#use fast_io(B)

#byte port_b = 6

main()
{
  int cont_piezas;

  port_b = 0;
  set_tris_a(0x1F);
  set_tris_b(0x00);

  while(1)
  {
    cont_piezas = 10;

    do {
      restart_wdt();
    } while(!input(PIN_A0));

    output_bit(PIN_B0,0);	// Desactivar "M1"
    output_bit(PIN_B1,1);	// Activar "M2"

    do {
      restart_wdt();
    } while(!input(PIN_A2));	// Esperar sensor "DE"

    output_bit(PIN_B0,1);	// Activar "M1"
    output_bit(PIN_B1,0);	// Desactivar "M2"
    output_bit(PIN_B2,0);	// Desactivar seal acstica

    do {

      do {
        restart_wdt();
      } while(!input(PIN_A1));	// Esperar activacin sensor "DP"

      do {
        restart_wdt();
      } while(input(PIN_A1));	// Esperar desactivacin sensor "DP"

      cont_piezas--;
    } while(cont_piezas);

    output_bit(PIN_B0,0);	// Desactivar "M1"
    output_bit(PIN_B1,1);	// Activar "M2"
    output_bit(PIN_B2,1);	// Activar seal acstica

    do {
      restart_wdt();
    } while(input(PIN_A2));	// Esperar desactivacin sensor "DE"
  }
}
