/*-------------------------------------------*\
 |  EJEMPLO 2.9                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para simulacin y/o MicroPIC Trainer

// Juego de luces, otra temporizacin.

// Se desea realizar una rotacin secuencial en el encendido de cada led
// conectado a la puerta B en la Trainer. Si RA0==0, la rotacin ser de
// derecha a izquierda y viceversa. Cada led permanece encendido 0.25
// segundos (250ms)

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#byte port_b = 6

main()
{
  port_b = 1;
  set_tris_b(0x00);

  while(1)
  {
    restart_wdt();
    if(input(PIN_A0))
      rotate_left(&port_b,1);
    else
      rotate_right(&port_b,1);
    delay_ms(250);
  }
}
