/*-------------------------------------------*\
 |  EJEMPLO 3.1                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Introduccin al manejo del teclado.

// Haciendo uso de las rutinas incluidas en el fichero KBD2.C, se trata de leer
// el teclado y, visualizar sobre los leds de la puerta B el cdigo binario de la
// tecla pulsada. La visualizacin se mantiene estable durante dos segundos hasta
// una nueva pulsacin

// Se trata de un ejemplo en el que la puerta B se reconfigura dinmicamente.
// Inicialmente es configurada como salida para presentacin del resultado.
// Posteriormente, la rutina de exploracin del teclado reconfigura RB0-RB3 como
// entradas y RB4-RB7 como salidas.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use fast_io(B)
#include <kbd2.c>

#byte port_b = 6

main()
{
  char k;

  while(1)
  {
     restart_wdt();
     k=kbd_getc();	// Comprueba el teclado, si k es 0 no se puls
     if(k)		// ninguna tecla, si no es 0 contiene el cdigo
     {			// ASCII de la tecla pulsada.

       set_tris_b(0x00);	// ATENCION: Necesario puesto que la funcin
       port_b = k;		// kbd_getc() reprograma la puerta B.
       delay_ms(2000);
     }
  }
}
