/*-------------------------------------------*\
 |  EJEMPLO 3.12                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Interface I2C gestionado por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de controlar el funcionamiento de los distintos dispositivos I2C, existentes
// en la tarjeta Trainer PLUS. Estos dispositivos estn conectados entre s al bus
// I2C comn. Se recomienda leer las especificaciones tcnicas de los mismos, para
// tener un mayor conocimiento de sus posibilidades. Igualmente es importane
// desconectar los leds de la MicroPIC Trainer mediante el jumper J7 pues de lo
// contrario actuaran como carga adicional en las lneas RB6 y RB7 que, es estos
// ejemplos, forman el bus I2C.

// El dispositivo I2C PCF8574. Puerto de E/S de 8 bits.

// Los leds de la Trainer PLUS que pilotan el estado de las lneas de E/S del
// PCF8574 estn complementados. Es decir, se activan cuando la lnea
// correspondiente est a "0".

// El programa explora el teclado de la Trainer PLUS y saca por la puerta de
// salida el valor binario del octeto tecleado. Este valor se ver reflejado
// en los leds que pilotan los niveles lgicos presentes en las lneas de
// salidas.


#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use I2C(MASTER,SDA=PIN_B6,SCL=PIN_B7,SLOW,RESTART_WDT)

#use fast_io(B)
#include <kbd2.c>

main()
{
  char k;

  while(1)
  {
    restart_wdt();
    k = kbd_getc();
    if(k)
    {
      i2c_start();
      i2c_write(0b01110000);
      i2c_write(~k);
      i2c_stop();
    }
  }
}
