/*-------------------------------------------*\
 |  EJEMPLO 3.13                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Interface I2C gestionado por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de controlar el funcionamiento de los distintos dispositivos I2C, existentes
// en la tarjeta Trainer PLUS. Estos dispositivos estn conectados entre s al bus
// I2C comn. Se recomienda leer las especificaciones tcnicas de los mismos, para
// tener un mayor conocimiento de sus posibilidades. Igualmente es importane
// desconectar los leds de la MicroPIC Trainer mediante el jumper J7 pues de lo
// contrario actuaran como carga adicional en las lneas RB6 y RB7 que, es estos
// ejemplos, forman el bus I2C.

// El dispositivo I2C PCF8574. Puerto de E/S de 8 bits.

// Los leds de la Trainer PLUS que pilotan el estado de las lneas de E/S del
// PCF8574 estn complementados. Es decir, se activan cuando la lnea
// correspondiente est a "0".

// El programa lee el estado lgico de las bornas D0-D7 que, en el Trainer PLUS,
// estn conectadas a las lneas de E/S del PCF8574. Dicho estado se visualiza
// en la pantalla LCD de la Trainer.


#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use I2C(MASTER,SDA=PIN_B6,SCL=PIN_B7,SLOW,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)
#include <lcd2.c>


main()
{
  int dato, x;
  signed int i;

  lcd_init();
  lcd_gotoxy(1,1);
  lcd_putc(" 7 6 5 4 3 2 1 0");

  while(1)
  {
    restart_wdt();
    i2c_start();
    i2c_write(0b01110001);  // Operacin de lectura sobre el PCF8574.
    dato=i2c_read();	    // Leer el dato.
    i2c_stop();

    for(i=7,x=2; i>=0; i--,x+=2)
    {
      lcd_gotoxy(x,2);
      if(bit_test(dato,i))
        lcd_putc('1');
      else
        lcd_putc('0');
    }
  }
}
