/*-------------------------------------------*\
 |  EJEMPLO 3.14                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Interface I2C gestionado por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de controlar el funcionamiento de los distintos dispositivos I2C, existentes
// en la tarjeta Trainer PLUS. Estos dispositivos estn conectados entre s al bus
// I2C comn. Se recomienda leer las especificaciones tcnicas de los mismos, para
// tener un mayor conocimiento de sus posibilidades. Igualmente es importane
// desconectar los leds de la MicroPIC Trainer mediante el jumper J7 pues de lo
// contrario actuaran como carga adicional en las lneas RB6 y RB7 que, es estos
// ejemplos, forman el bus I2C.

// El dispositivo I2C SAA1064. Controlador de displays 7 segmentos.

// Se trata de un simple programa que visualiza el valor "1234" sobre los cuatro
// displays de la MicroPIC Trainer PLUS. El valor a visualizar podra ser
// cualquier otro.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use I2C(MASTER,SDA=PIN_B6,SCL=PIN_B7,SLOW,RESTART_WDT)

main()
{
  unsigned int const disp[16]={0x3F,0x06,0x5B,0x4F,
                               0x66,0x6D,0x7D,0x27,
                               0x7F,0x6F,0x77,0x7C,
                               0x39,0x5E,0x79,0x71};
  while(1)
  {
    restart_wdt();
    i2c_start();
    i2c_write(0b01110110); // Direccin (Escritura)
    i2c_write(0b00000000); // Instruccin
    i2c_write(0b01000111); // Control
    i2c_write(disp[0]);
    i2c_write(disp[1]);
    i2c_write(disp[2]);
    i2c_write(disp[3]);
    i2c_stop();
  }
}
