/*-------------------------------------------*\
 |  EJEMPLO 3.17                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Interface I2C gestionado por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de controlar el funcionamiento de los distintos dispositivos I2C, existentes
// en la tarjeta Trainer PLUS. Estos dispositivos estn conectados entre s al bus
// I2C comn. Se recomienda leer las especificaciones tcnicas de los mismos, para
// tener un mayor conocimiento de sus posibilidades. Igualmente es importane
// desconectar los leds de la MicroPIC Trainer mediante el jumper J7 pues de lo
// contrario actuaran como carga adicional en las lneas RB6 y RB7 que, es estos
// ejemplos, forman el bus I2C.

// El dispositivo I2C PCF8591. Convertidor DAC y ADC

// El programa saca, mediante el convertido DAC presente en el dispositivo I2C
// PCF8591, una tensin analgica creciente entre 0 y 5v y vuelta a empezar. Dicha
// tensin puede ser medida mediante un polmetro colocado entre las bornas GND y
// AOUT de la placa MicroPIC Trainer PLUS. Si se activa el interruptor de entrada
// RA0, la tensin AOUT pasa a 0v y se mantiene hasta desactivar RA0.


#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use I2C(MASTER,SDA=PIN_B6,SCL=PIN_B7,SLOW,RESTART_WDT)

#use fast_io(A)

#byte port_b = 6

int v=0;

void i2c_dac(void)
{
  i2c_start();
  i2c_write(0b10010000);  // Direccin del PCF8591 (escritura)
  i2c_write(0b01000000);  // Byte de control
  i2c_write(v);           // Dato a convertir a analgico
  i2c_stop();
}

main()
{
  set_tris_a(0x01);
  
  while(1)
  {
    restart_wdt();
    v++;
    i2c_dac();
    delay_ms(20);
    if(input(PIN_A0))
    {
      v = 0;
      i2c_dac();     
      delay_ms(20);
      while(input(PIN_A0))
        restart_wdt();
      delay_ms(20);
    }
  }
}
