/*-------------------------------------------*\
 |  EJEMPLO 3.19                             |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Interface I2C gestionado por software.

// Haciendo uso de las rutinas incluidas las librerias del compilador C, se trata
// de controlar el funcionamiento de los distintos dispositivos I2C, existentes
// en la tarjeta Trainer PLUS. Estos dispositivos estn conectados entre s al bus
// I2C comn. Se recomienda leer las especificaciones tcnicas de los mismos, para
// tener un mayor conocimiento de sus posibilidades. Igualmente es importane
// desconectar los leds de la MicroPIC Trainer mediante el jumper J7 pues de lo
// contrario actuaran como carga adicional en las lneas RB6 y RB7 que, es estos
// ejemplos, forman el bus I2C.

// El dispositivo I2C PCF8591. Convertidor DAC y ADC

// El programa explora el teclado de la MicroPIC Trainer PLUS y saca por la puerta
// de salida del PCF8574 el valor binario del octeto tecleado. Este valor se ver
// reflejado en los leds del MicroPIC Trainer PLUS que pilotan los niveles lgicos
// presentes en las lneas de E/S. Posteriormente dicho octeto se enva al DAC del
// PCF8591 que generar una tensin analgica proporcional. Dicha tensin est
// disponible en la borna AOUT de la MicroPIC Trainer PLUS y podr ser medida con
// un polmetro


#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use I2C(MASTER,SDA=PIN_B6,SCL=PIN_B7,SLOW,RESTART_WDT)

#use fast_io(A)
#use fast_io(B)

#include <kbd2.c>
#include <ctype.h>

int k=0;

void i2c_dac(void)
{
  i2c_start();
  i2c_write(0b10010000);
  i2c_write(0b01000000);
  i2c_write(k);
  i2c_stop();
}

void i2c_salida(void)
{
  i2c_start();
  i2c_write(0b01110000);
  i2c_write(~k);
  i2c_stop();
}

main()
{
  while(1)
  {
    restart_wdt();
    i2c_dac();
    i2c_salida();
    do
    {
      k=kbd_getc();
      restart_wdt();
    } while(!k);

    k = isdigit(k)? k-'0': k-'A'+10;
    k <<= 4;
  }
}
