/*-------------------------------------------*\
 |  EJEMPLO 3.2                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// Introduccin al manejo del teclado.

// Haciendo uso de las rutinas incluidas en el fichero KBD2.C, se trata de leer
// el teclado y, visualizar sobre el display de lapuerta B el numero de la tecla
// pulsada. La visualizacin se mantiene estable durante dos segundos hasta
// una nueva pulsacin.

// Se trata de un ejemplo en el que la puerta B se reconfigura dinmicamente.
// Inicialmente es configurada como salida para presentacin del resultado.
// Posteriormente, la rutina de exploracin del teclado reconfigura RB0-RB3 como
// entradas y RB4-RB7 como salidas.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use fast_io(B)
#include <kbd2.c>

#byte port_b = 6

main()
{
  unsigned int const disp[16]={0x3F,0x06,0x5B,0x4F,
                               0x66,0x6D,0x7D,0x27,
                               0x7F,0x6F,0x77,0x7C,
                               0x39,0x5E,0x79,0x71};
  int k;

  while(1)
  {
     k = kbd_getc();
     if(k)
     {
       set_tris_b(0x00);
       if( (k >= '0') && (k <= '9') )
         port_b = disp[k-'0'];
       else
         port_b = disp[k-'A'+10];
       delay_ms(2000);
      }
   }
}
