/*-------------------------------------------*\
 |  EJEMPLO 3.3                              |
 |  Autor: Pedro M Jimnez                  |
 |  (c) Microsystems Engineering (Bilbao)    |
\*-------------------------------------------*/

// Ejemplo para MicroPIC Trainer y Trainer PLUS

// El teclado y el LCD.

// Haciendo uso de las rutinas incluidas en los ficheros LCD2.C y KBD2.C, se trata
// de leer el teclado y, visualizar sobre el mdulo LCD el codigo hex. de la tecla
// pulsada.

// El ejemplo pretende mostrar cmo es posible gobernar dos perifricos distintos
// conectados a la misma puerta (LCD y teclado). Para ello basta reprogramarla
// dinmicamente en el tiempo segn sea necesario.

#include <16f84.h>

#use delay(clock=4000000,RESTART_WDT)
#use fast_io(A)
#use fast_io(B)
#include <kbd2.c>
#include <lcd2.c>


main()
{
  char k;

  lcd_init();			// Inicializar LCD
  lcd_putc("Tecla pulsada:");

  while(1)
  {
     restart_wdt();
     k = kbd_getc();		// Leer tecla.
     if(k)
     {
        lcd_gotoxy(16,1);
        lcd_putc(k);		// Visualizar la tecla pulsada en el LCD.
     }

  }
}
