;
;					EJEMPLO 3.6
;
;				Autor: Mikel Etxebarria
;			(c) Microsystems Engineering (Bilbao)
;
;Ejemplo para MicroPIC Trainer y Trainer PLUS. Comunicacin serie gestionada por software.
;
;Haciendo uso de las rutinas incluidas en el fichero RS232LOW.INC, se trata de utilizar el
;canal RS232 de la Trainer PLUS para comunicar va serie con diferentes perifricos. En los
;ejemplos aqu propuestos se utilizar un PC para que, con el software TERMINAL.EXE, actue
;como un simple terminal de comunicaciones. El usuario deber preparar los cables de comuni-
;cacin entre la Trainer PLUS y el PC, teniendo en cuenta de cruzar la seal de Transmisin
;(TxD) con la de recepcin (RxD) y viceversa.
;
;Este ejemplo propone esperar a recibir un carcter desde el terminal para, inmediatamente,
;retransmitirlo al mismo a modo de ECO.

		List	p=16F84		;Tipo de procesador
		include	"P16F84.INC"	;Definiciones de registros internos

CLKIN		equ	.4000000	;Frecuencia de trabajo
BAUDIOS		equ	.9600		;Velocidad de comunicacin
T_MODO		equ	1		;Transmite primero bit LSB
R_MODO		equ	1		;Recibir primero bit LSB
T_Nbit		equ	8		;Transmite caracteres de 8 bits
R_Nbit		equ	8		;Recibe caracteres de 8 bits
Sbit		equ	2		;Transmite 2 bits de stop
                 
Rs232_var	equ	0x0c		;Inicio de las variables para rutinas RS232
					
		org	0x00		;Vector de reset
		goto	Inicio
		org	0x05		;Salvar el vector de interrupcin	
					
		include	"RS232LOW.INC"	;Incluir rutinas de comunicacin
							
;****************************************************************************************
;Programa Principal

Inicio:		bsf	STATUS,RP0	;Selecciona pgina 1 de datos
		movlw	b'10001111'	;Preescaler de 128 para el WDT. Pull_Up Off
		movwf	OPTION_REG	
		movlw	b'11101111'
		movwf	TRISB		;RB5 entrada y RB4 salida
		bcf	STATUS,RP0	;Selecciona pgina 0 de datos	
		
Loop		clrwdt
		bsf	Txd_pin		;Lnea de transmisin a "1"
		bsf	Rxd_pin		;Lnea de recepcin a "1"

		call	RxD		;Espera a recibir un carcter
		movf	Rxdreg,W	;Lee el carcter recibido
		movwf	Txdreg
		call	TxD		;Retransmite carcter recibido (ECO)
		
		goto	Loop

		end			;Fin del programa fuente

