;
;					EJEMPLO 1
;
;				Autor: Mikel Etxebarria
;			(c) Microsystems Engineering (Bilbao)
;
;Ejemplo para simulacin y/o MicroPIC Trainer
;
;Simple ejemplo de E/S con los PIC 16F87X
;
;Leer el estado de los 5 interruptores de la Trainer (RA4-RA0) y reflejar el nivel
;lgico de los mismos sobre los leds RB4-RB0 conectados a la puerta B
		
		List	p=16F873	;Tipo de procesador
		include	"P16F873.INC"	;Definiciones de registros internos


		org	0x00		;Vector de Reset
		goto	Inicio

		org	0x05		;Salva el vector de interrupcin

Inicio	        clrf 	PORTB		;Borra los latch de salida
		bsf	STATUS,RP0	;Selecciona banco 1
		movlw	b'00000110'
		movwf	ADCON1		;Puerta A E/S digitales
		clrf	TRISB		;Puerta B se configura como salida
		movlw	b'00011111'		
		movwf	TRISA		;Puerta A se configura como entrada
		bcf	STATUS,RP0	;Selecciona banco 0

Loop		movf	PORTA,W		;Leer las entradas RA0-RA4
		movwf	PORTB		;Reflejar en las salidas
		goto	Loop		;Bucle sin fin

		end			;Fin del programa fuente
